///////////////////////////////////////////////////////////////////////////////
//
// Copyright  1995-1997 Somarsoft, Inc, All Rights Reserved
//
#define STRICT
#pragma warning(disable: 4001) /* double slash type comments */
#pragma warning(disable: 4201) /* non-standard extensions */
#pragma warning(disable: 4209) /* non-standard extensions */
#pragma warning(disable: 4214) /* non-standard extensions */
#include <windows.h>
#pragma warning(disable: 4001) /* double slash type comments */
#include <ipexport.h>
// #include <icmpapi.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <process.h>
#pragma warning(disable: 4001) /* double slash type comments */
#include <ras.h>
#pragma warning(disable: 4001) /* double slash type comments */
#include <raserror.h>
#pragma hdrstop

#pragma warning(disable: 4001) /* double slash type comments */
#pragma warning(disable: 4514) // unreferenced inline functions

typedef DWORD (APIENTRY * RASDIAL) (LPRASDIALEXTENSIONS, LPSTR, LPRASDIALPARAMSA, 
                                    DWORD, LPVOID, LPHRASCONN);
typedef DWORD (APIENTRY * RASGETCONNECTSTATUS) (HRASCONN, LPRASCONNSTATUSA);
typedef DWORD (APIENTRY * RASGETERRORSTRING) (UINT, LPSTR, DWORD);
typedef DWORD (APIENTRY * RASHANGUP) (HRASCONN);
typedef DWORD (APIENTRY * RASENUMCONNECTIONS) (LPRASCONN, LPDWORD, LPDWORD);

typedef HANDLE (WINAPI* ICMPCREATEFILE) (VOID);
typedef BOOL   (WINAPI* ICMPCLOSEHANDLE) (HANDLE);
typedef DWORD  (WINAPI* ICMPSENDECHO) (HANDLE, IPAddr, LPVOID, WORD, 
                                       PIP_OPTION_INFORMATION,
                                       LPVOID, DWORD, DWORD);

///////////////////////////////////////////////////////////////////////////////
//
// function prototypes
//
VOID ServiceMain(DWORD dwArgc, LPTSTR *lpszArgv);
VOID ServiceCtrl(DWORD dwCtrlCode);
void ReportStatusToSCMgr(DWORD dwCurrentState,
                            DWORD dwWin32ExitCode,
                            DWORD dwCheckPoint,
                            DWORD dwWaitHint);
void Install();
void UnInstall();
void Trace(DWORD dwEventID, LPCTSTR pszFmt, ...);
void WorkerThread(void *);

///////////////////////////////////////////////////////////////////////////////
//
// global constants
//
#define EVENT_CONNECT    1
#define EVENT_DISCONNECT 2
#define EVENT_ERROR      3
#define EVENT_INFO       4
#define EVENT_PINGFAIL   5

static LPCTSTR g_szServiceName = "SomarReDial";
static LPCTSTR g_szEventKey = 
    "SYSTEM\\CurrentControlSet\\Services\\EventLog\\Application\\Somar ReDial";

static LPCTSTR g_szSection     = "Parms";

#define MAX_SERVICES 20
#define MAX_SERVICE_NAME 256
typedef struct _SERVICE_NAME {
    TCHAR           szDisplayName[MAX_SERVICE_NAME];
    TCHAR           szServiceName[MAX_SERVICE_NAME];
    struct _SERVICE_NAME*  pNext;
} SERVICE_NAME, *PSERVICE_NAME;

///////////////////////////////////////////////////////////////////////////////
//
// global variables
//
HANDLE                  g_hServDoneEvent = NULL;

BOOL                    g_fService = FALSE;
SERVICE_STATUS_HANDLE   g_hServiceStatus = 0;
SERVICE_STATUS          g_ServiceStatus;

int                     g_nServices = 0;
PSERVICE_NAME           g_pServices = NULL;

TCHAR                   g_szEntryName[RAS_MaxEntryName+1];
TCHAR                   g_szUserName[UNLEN+1];
TCHAR                   g_szPassword[PWLEN+1];
TCHAR                   g_szDomain[DNLEN+1];
TCHAR                   g_szUsePrefixSuffix[10];
TCHAR                   g_szPhonebook[MAX_PATH+1];
LPTSTR                  g_pszPhonebook = NULL;
DWORD                   g_nMaxTrysIn1Hour = 0;
DWORD                   g_nPingInterval = 0;
DWORD                   g_nMaxPingFailures = 0;
DWORD                   g_nPingTimeout = 2000;
DWORD                   g_nPingIterations = 5;
DWORD                   g_fVerbose = 0;
DWORD                   g_nRedialInterval = 10;

#define MAX_PINGADDR 10
DWORD                   g_nPingAddr = 0;
struct in_addr          g_PingAddr[MAX_PINGADDR];

///////////////////////////////////////////////////////////////////////////////
void main(int argc, char *argv[])
{
    static SERVICE_TABLE_ENTRY dispatchTable[] = {
        {"SomarReDial", (LPSERVICE_MAIN_FUNCTION) ServiceMain},
        {NULL, NULL}
    };

    if (argc == 2 && lstrcmpi(argv[1], "/Install") == 0) {
        Install();
    }
    else if (argc == 2 && lstrcmpi(argv[1], "/Uninstall") == 0) {
        UnInstall();
    }
    else if (argc == 2 && lstrcmpi(argv[1], "/Run") == 0) {
        g_hServDoneEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
        if (g_hServDoneEvent) {
            g_fService = FALSE;
            WorkerThread(NULL);
        }
    }
    else if (argc == 2 && lstrcmpi(argv[1], "/?") == 0) {
        printf("Usage: redial /install     (installs service)\n");
        printf("       redial /uninstall   (uninstalls service)\n");
        printf("       redial /run         (runs as a console program for debugging)\n");
        printf("       redial /?           (display help)\n");
        printf("Somarsoft ReDial is Copyright  1995-1997 Somarsoft,Inc\n");
        printf("Send problem reports and comments to info@somarsoft.com\n");
        printf("Visit the Somarsoft web site at http://www.somarsoft.com\n");
        printf("Somar ReDial reads REDIAL.INI in the same directory as REDIAL.EXE\n");
        printf("Example of REDIAL.INI (items start in column 1)\n");
        printf("   Entry=DIGEX\n");
        printf("   UserName=myusername\n");
        printf("   Password=mypassword\n");
        printf("   Domain=mydomain       (optional)\n");
        printf("   UsePrefixSuffix=Yes   (optional)\n");
        printf("   Phonebook=filename    (optional)\n");
        printf("   Service0=https        (optional)\n");
        printf("   Service1=SMTPD        (optional)\n");
        printf("   PingInterval=60       (optional)\n");
        printf("   MaxPingFailures=20    (optional)\n");
        printf("   RedialInterval=10     (optional)\n");
    }
    else {
        g_fService = TRUE;
	    if (!StartServiceCtrlDispatcher(dispatchTable)) {
            SetEvent(g_hServDoneEvent);
        }
    }
}

///////////////////////////////////////////////////////////////////////////////
VOID ServiceMain(DWORD dwArgc, LPTSTR *lpszArgv)
{
    UINT            dwThreadID;
    DWORD           dwWait;
    HANDLE          hThread;
    HANDLE          WaitList[2];

    hThread = NULL;

    g_hServiceStatus = RegisterServiceCtrlHandler(g_szServiceName,
                                    (LPHANDLER_FUNCTION)ServiceCtrl);
    if (!g_hServiceStatus)
        goto cleanup;

    g_ServiceStatus.dwServiceType = SERVICE_WIN32_OWN_PROCESS;
    g_ServiceStatus.dwServiceSpecificExitCode = 0;

    ReportStatusToSCMgr(SERVICE_START_PENDING, NO_ERROR, 1, 3000);

    g_hServDoneEvent = CreateEvent(NULL, TRUE, FALSE, NULL);
    if (g_hServDoneEvent == (HANDLE)NULL)
        goto cleanup;

    ReportStatusToSCMgr(SERVICE_START_PENDING, NO_ERROR, 2, 3000);
    ReportStatusToSCMgr(SERVICE_RUNNING, NO_ERROR, 0, 0);

    while (TRUE) {
        hThread = (HANDLE) _beginthreadex(NULL,   // security attributes
                                          0,      // inherit parent's stack size
                                          (LPTHREAD_START_ROUTINE) WorkerThread,
                                          NULL,   // argument to thread
                                          0,      // flags
                                          &dwThreadID);  // thread ID
        if (!hThread)
            goto cleanup;

        WaitList[0] = g_hServDoneEvent;
        WaitList[1] = hThread;
        dwWait = WaitForMultipleObjects(2, WaitList, FALSE, INFINITE);
        if (dwWait == WAIT_OBJECT_0)
            goto cleanup;

        Trace(EVENT_ERROR, "WorkerThread failed");

        dwWait = WaitForSingleObject(g_hServDoneEvent, 60000); // delay 60 seconds
        if (dwWait == WAIT_OBJECT_0)
            goto cleanup;
    }

cleanup:
    if (hThread) {
        dwWait = WaitForSingleObject(hThread, 120000); // wait at most 2 minutes for thread
        if (dwWait == WAIT_OBJECT_0)
            CloseHandle(hThread);
    }

    if (g_hServDoneEvent != NULL)
        CloseHandle(g_hServDoneEvent);

    if (g_hServiceStatus != 0)
        ReportStatusToSCMgr(SERVICE_STOPPED, 0, 0, 0);

    return;
}

///////////////////////////////////////////////////////////////////////////////
VOID ServiceCtrl(DWORD dwCtrlCode)
{
    DWORD  dwState = SERVICE_RUNNING;

    switch(dwCtrlCode) {
        case SERVICE_CONTROL_PAUSE:
            if (g_ServiceStatus.dwCurrentState == SERVICE_RUNNING)
                dwState = SERVICE_PAUSED;
            break;
        case SERVICE_CONTROL_CONTINUE:
            if (g_ServiceStatus.dwCurrentState == SERVICE_PAUSED)
                dwState = SERVICE_RUNNING;
            break;
        case SERVICE_CONTROL_STOP:
            dwState = SERVICE_STOP_PENDING;
            ReportStatusToSCMgr(SERVICE_STOP_PENDING, NO_ERROR, 1, 3000);
            SetEvent(g_hServDoneEvent);
            return;
        case SERVICE_CONTROL_INTERROGATE:
            break;
        default:
            break;
    }
    ReportStatusToSCMgr(dwState, NO_ERROR, 0, 0);
}

///////////////////////////////////////////////////////////////////////////////
void ReportStatusToSCMgr(DWORD dwCurrentState,
                         DWORD dwWin32ExitCode,
                         DWORD dwCheckPoint,
                         DWORD dwWaitHint)
{
    if (dwCurrentState == SERVICE_START_PENDING)
        g_ServiceStatus.dwControlsAccepted = 0;
    else
        g_ServiceStatus.dwControlsAccepted = SERVICE_ACCEPT_STOP | SERVICE_ACCEPT_PAUSE_CONTINUE;
    g_ServiceStatus.dwCurrentState  = dwCurrentState;
    g_ServiceStatus.dwWin32ExitCode = dwWin32ExitCode;
    g_ServiceStatus.dwCheckPoint    = dwCheckPoint;
    g_ServiceStatus.dwWaitHint      = dwWaitHint;
    if (!SetServiceStatus(g_hServiceStatus, &g_ServiceStatus)) {
        SetEvent(g_hServDoneEvent);
    }
}

///////////////////////////////////////////////////////////////////////////////
void Install()
{
   	SC_HANDLE      	schSCMgr;
   	SC_HANDLE      	scService;
   	LONG           	lRetCode;
    TCHAR           szPath[MAX_PATH+1];
    HKEY            hKey;
    DWORD           dwTemp;

    GetModuleFileName(NULL, szPath, MAX_PATH);
    szPath[MAX_PATH] = 0; // ensure null termination

    schSCMgr = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
    if (schSCMgr) {
		scService = CreateService(schSCMgr,
    	                          g_szServiceName,
        	                      g_szServiceName,
            	                  SERVICE_ALL_ACCESS,
                	              SERVICE_WIN32_OWN_PROCESS,
                    	          SERVICE_AUTO_START,
                        	      SERVICE_ERROR_NORMAL,
                            	  szPath,
	                              NULL,  // load order group
    	                          NULL,  // tag ID
        	                      NULL,  // dependencies
            	                  NULL,  // account name
	                              NULL); // password 
		if (scService) {
            lRetCode = RegCreateKeyEx (HKEY_LOCAL_MACHINE, g_szEventKey,
                                      0, NULL, REG_OPTION_NON_VOLATILE, KEY_WRITE,
                                      NULL, &hKey, &dwTemp);
            if (lRetCode == ERROR_SUCCESS) {
                lRetCode = RegSetValueEx (hKey, "EventMessageFile", 0, REG_EXPAND_SZ,
                                        (LPBYTE) szPath, lstrlen(szPath) + 1);

                dwTemp = EVENTLOG_ERROR_TYPE | EVENTLOG_WARNING_TYPE | EVENTLOG_INFORMATION_TYPE;
                lRetCode = RegSetValueEx (hKey, "TypesSupported", 0, REG_DWORD,
                                        (LPBYTE) &dwTemp, sizeof(DWORD));

                lRetCode = RegCloseKey (hKey);
                printf("SomarReDial service has been successfully installed\n");
            }
            else {
                printf("==>Unable to create EventLog key rc=%lu\n", GetLastError());
            }
		    CloseServiceHandle(scService);
		}
        else {
            printf("==>CreateService failed, rc=%lu\n", GetLastError());
        }
        CloseServiceHandle(schSCMgr);
    }
    else {
        printf("==>OpenSCManager failed, rc=%lu\n", GetLastError());
    }
}

///////////////////////////////////////////////////////////////////////////////
void UnInstall()
{
   	SC_HANDLE      	schSCMgr;
   	SC_HANDLE      	scService;
   	LONG           	lRetCode;

    schSCMgr = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
    if (schSCMgr) {
        scService = OpenService(schSCMgr, g_szServiceName, SERVICE_ALL_ACCESS);
    	if (scService) {
        	if (DeleteService(scService)) {
                printf("SomarReDial service has been successfully uninstalled\n");
                lRetCode = RegDeleteKey(HKEY_LOCAL_MACHINE, g_szEventKey);
			}
            else {
                printf("==>DeleteService failed, rc=%lu\n", GetLastError());
            }
        	CloseServiceHandle(scService);
	    }
        else {
            printf("==>OpenService failed, rc=%lu\n", GetLastError());
        }
        CloseServiceHandle(schSCMgr);
	}
    else {
        printf("==>OpenSCManager failed, rc=%lu\n", GetLastError());
	}
}

///////////////////////////////////////////////////////////////////////////////
void Trace(DWORD dwEventID, LPCTSTR pszFmt, ...)
{
    BOOL        fResult;
    WORD        wType;
	TCHAR       buf[1000];
	va_list	    vargs;
    LPCTSTR     psz;
    HANDLE      hEventSource;

	va_start(vargs, pszFmt);
    #ifdef UNICODE
	wvsprintf(buf, pszFmt, vargs);
    #else
	vsprintf(buf, pszFmt, vargs);
    #endif
	va_end(vargs);

    if (g_fService) {
        switch(dwEventID) {
            case EVENT_INFO:
            case EVENT_CONNECT: 
                wType = EVENTLOG_INFORMATION_TYPE; 
                break;
            case EVENT_DISCONNECT: 
            case EVENT_PINGFAIL:
                wType = EVENTLOG_WARNING_TYPE;     
                break;
            case EVENT_ERROR:
            default: 
                dwEventID = EVENT_ERROR;
                wType = EVENTLOG_ERROR_TYPE;       
                break;  
        }
        psz = buf;
        hEventSource = RegisterEventSource(NULL, "Somar ReDial");
        if (hEventSource != NULL) {
            fResult = ReportEvent(hEventSource, wType, 0,
                                  dwEventID, NULL, 1, 0, &psz, NULL);
            DeregisterEventSource(hEventSource);
        }
    }
    else {
        printf(buf);
        printf("\n");
    }
}

///////////////////////////////////////////////////////////////////////////////
void StartServices()
{
    SC_HANDLE       hSCMgr;
    SC_HANDLE       hService;
    BOOL            fResult;
    PSERVICE_NAME   pService;

    hSCMgr = OpenSCManager(NULL, NULL, GENERIC_EXECUTE);
    if (hSCMgr) {
        pService = g_pServices;
        while (pService) {
            hService = OpenService(hSCMgr, pService->szServiceName, GENERIC_EXECUTE);
            if (hService) {
                fResult = StartService(hService, 0, NULL);
                if (!fResult) {
                    Trace(EVENT_ERROR, "StartService failed for %s, rc=%lu", 
                          pService->szServiceName, GetLastError());
                }            
                CloseServiceHandle(hService);
            }
            else {
                Trace(EVENT_ERROR, "OpenService failed for %s, rc=%lu", 
                       pService->szServiceName, GetLastError());
            }
            pService = pService->pNext;
        }
        CloseServiceHandle(hSCMgr);
    }
    else {
        Trace(EVENT_ERROR, "OpenSCManager failed, rc=%lu", GetLastError());
    }
}

///////////////////////////////////////////////////////////////////////////////
void StopServices()
{
    SC_HANDLE       hSCMgr;
    SC_HANDLE       hService;
    SERVICE_STATUS  ServiceStatus;
    BOOL            fResult;
    PSERVICE_NAME   pService;

    hSCMgr = OpenSCManager(NULL, NULL, GENERIC_EXECUTE);
    if (hSCMgr) {
        pService = g_pServices;
        while (pService) {
            hService = OpenService(hSCMgr, pService->szServiceName, GENERIC_EXECUTE);
            if (hService) {
                fResult = ControlService(hService, SERVICE_CONTROL_STOP, &ServiceStatus);
                if (!fResult) {
                    // error is normal for STOP, if service not currently running
                    // Trace(EVENT_ERROR, "ControlService failed for %s, rc=%lu", 
                    //      pService->szServiceName, GetLastError());
                }            
                CloseServiceHandle(hService);
            }
            else {
                // Trace(EVENT_ERROR, "OpenService failed for %s, rc=%lu", 
                //       pService->szServiceName, GetLastError());
                // if open service fails for the start, don't log again for the stop
            }
            pService = pService->pNext;
        }
        CloseServiceHandle(hSCMgr);
    }
    else {
        Trace(EVENT_ERROR, "OpenSCManager failed, rc=%lu", GetLastError());
    }
}

///////////////////////////////////////////////////////////////////////////////
BOOL ReadInitParms()
{
    DWORD               dwBytes;
    DWORD               dwResult;
    TCHAR               szPath[MAX_PATH+1];

    dwBytes = GetModuleFileName(NULL, szPath, MAX_PATH);
    if (dwBytes == 0 || dwBytes < 10) {
        Trace(EVENT_ERROR, "GetModuleFileName failed, rc=%lu", GetLastError());
        return FALSE;
    }
    lstrcpy(szPath + dwBytes - 3, "INI"); // replace .EXE with .INI

    dwResult = GetPrivateProfileString(g_szSection, "EntryName", "", 
                                       g_szEntryName, sizeof(g_szEntryName), szPath);
    if (dwResult == 0) {
        Trace(EVENT_ERROR, "Missing EntryName in REDIAL.INI");
        return FALSE;
    }
    dwResult = GetPrivateProfileString(g_szSection, "UserName", "", 
                                       g_szUserName, sizeof(g_szUserName), szPath);
    if (dwResult == 0) {
        Trace(EVENT_ERROR, "Missing UserName in REDIAL.INI");
        return FALSE;
    }
    dwResult = GetPrivateProfileString(g_szSection, "Password", "", 
                                       g_szPassword, sizeof(g_szPassword), szPath);
    if (dwResult == 0) {
        Trace(EVENT_ERROR, "Missing Password in REDIAL.INI");
        return FALSE;
    }

    dwResult = GetPrivateProfileString(g_szSection, "Domain", "", 
                                       g_szDomain, sizeof(g_szDomain), szPath);
    if (dwResult == 0)
        g_szDomain[0] = 0;
    
    dwResult = GetPrivateProfileString(g_szSection, "Phonebook", "", 
                                       g_szPhonebook, sizeof(g_szPhonebook), szPath);
    if (dwResult == 0)
        g_pszPhonebook = NULL;
    else
        g_pszPhonebook = g_szPhonebook;

    dwResult = GetPrivateProfileString(g_szSection, "UsePrefixSuffix", "", 
                                       g_szUsePrefixSuffix, sizeof(g_szUsePrefixSuffix), szPath);

    g_nMaxTrysIn1Hour = GetPrivateProfileInt(g_szSection, "MaxTrysIn1Hour", 0, szPath);

    g_nPingInterval = GetPrivateProfileInt(g_szSection, "PingInterval", 0, szPath);
    g_nMaxPingFailures = GetPrivateProfileInt(g_szSection, "MaxPingFailures", 0, szPath);
    g_nPingTimeout = GetPrivateProfileInt(g_szSection, "PingTimeout", 2000, szPath);
    g_nPingIterations = GetPrivateProfileInt(g_szSection, "PingIterations", 5, szPath);
    g_nRedialInterval = GetPrivateProfileInt(g_szSection, "RedialInterval", 10, szPath);

    g_fVerbose = GetPrivateProfileInt(g_szSection, "Verbose", 0, szPath);

	return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
BOOL GetServiceNames()
{
    SC_HANDLE           hSCMgr;
    LPENUM_SERVICE_STATUS pStatus;
    BYTE                buf[4096];
    DWORD               dwCount;
    DWORD               dwBytes;
    DWORD               dwResult;
    DWORD               dwResume;
    BOOL                fMore;
    BOOL                fResult;
    PSERVICE_NAME       pService, pPrevService;
    TCHAR               szPath[MAX_PATH+1];
    TCHAR               szKey[20];
    TCHAR               szServiceName[MAX_SERVICE_NAME];
    int                 i;

    dwBytes = GetModuleFileName(NULL, szPath, MAX_PATH);
    if (dwBytes == 0 || dwBytes < 10) {
        Trace(EVENT_ERROR, "GetModuleFileName failed, rc=%lu", GetLastError());
        return FALSE;
    }
    lstrcpy(szPath + dwBytes - 3, "INI"); // replace .EXE with .INI

    pPrevService = NULL;
    for (i = 0; i < MAX_SERVICES; i++) {
        wsprintf(szKey, "Service%d", i);
        dwResult = GetPrivateProfileString(g_szSection, szKey, "", 
                                           szServiceName, sizeof(szServiceName), szPath);
        if (dwResult == 0) 
            break;
        
        pService = malloc(sizeof(SERVICE_NAME));
        if (pService == NULL) {
            Trace(EVENT_ERROR, "malloc failed");
            return FALSE;
        }
        lstrcpy(pService->szDisplayName, szServiceName);
        lstrcpy(pService->szServiceName, szServiceName);
        pService->pNext = NULL;
        if (pPrevService) {
            pPrevService->pNext = pService;
        }
        else {
            g_pServices = pService;
        }
        pPrevService = pService;
    }
    g_nServices = i;

        //
        // convert display name to internal name
        //
    hSCMgr = OpenSCManager(NULL, NULL, GENERIC_READ);
    if (hSCMgr) {
        dwResume = 0;
        fMore = TRUE;
        while (fMore) {
            fResult = EnumServicesStatus(hSCMgr, 
                                         SERVICE_WIN32,
                                         SERVICE_ACTIVE | SERVICE_INACTIVE,
                                         (LPENUM_SERVICE_STATUS) buf,
                                         sizeof(buf),
                                         &dwBytes,
                                         &dwCount,
                                         &dwResume);
            if (fResult) {
                fMore = FALSE;
            }
            else {
                if (GetLastError() == ERROR_MORE_DATA) {
                    fMore = TRUE;
                }
                else if (GetLastError() != ERROR_SUCCESS) {
                    Trace(EVENT_ERROR, "EnumServiceStatus failed, rc=%lu", 
                          GetLastError());
                    break;
                }
            }
            pStatus = (LPENUM_SERVICE_STATUS) buf;
            while (dwCount-- > 0) {
                pService = g_pServices;
                while (pService) {
                    if (lstrcmpi(pService->szDisplayName, pStatus->lpDisplayName) == 0) {
                        lstrcpy(pService->szServiceName, pStatus->lpServiceName);
                        break;
                    }
                    pService = pService->pNext;
                }
                pStatus++;
            }
        }
        CloseServiceHandle(hSCMgr);
    }
    else {
        Trace(EVENT_ERROR, "OpenSCManager failed, rc=%lu", GetLastError());
    }

    return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
LPSTR ConvertIP(LPSTR psz)
{
    int     digits, octet;
    BYTE    val;

    while(*psz == ' ' || *psz == '\t') psz++;
    for (octet = 0; octet < 4; octet++) {
        val = 0;
        digits = 0;
        while(*psz >= '0' && *psz <= '9') {
            digits++;
            val = val * 10 + *psz - '0'; 
            psz++;
        };
        if (digits == 0 || octet < 3 && *psz != '.') {
            return NULL;
        }
        if (octet < 3) psz++; // skip period
        switch (octet) {
            case 0: g_PingAddr[g_nPingAddr].S_un.S_un_b.s_b1 = val; break;
            case 1: g_PingAddr[g_nPingAddr].S_un.S_un_b.s_b2 = val; break;
            case 2: g_PingAddr[g_nPingAddr].S_un.S_un_b.s_b3 = val; break;
            case 3: g_PingAddr[g_nPingAddr].S_un.S_un_b.s_b4 = val; break;
        }
    }
    g_nPingAddr++;
    return psz;
}

///////////////////////////////////////////////////////////////////////////////
BOOL GetPingAddresses()
{
    TCHAR               szPath[MAX_PATH+1];
    TCHAR               szKey[20];
	HKEY                hKey;
	long                lRetCode;
	DWORD               dwcb;
    char                buf[4096];
    LPSTR               psz;

    if (g_nPingInterval == 0) return TRUE;

    g_nPingAddr = 0;

        //
        // get IP addresses from .INI file
        //
    dwcb = GetModuleFileName(NULL, szPath, MAX_PATH);
    if (dwcb == 0 || dwcb < 10) {
        Trace(EVENT_ERROR, "GetModuleFileName failed, rc=%lu", GetLastError());
        return FALSE;
    }
    lstrcpy(szPath + dwcb - 3, "INI"); // replace .EXE with .INI
    while (g_nPingAddr < MAX_PINGADDR) {
        wsprintf(szKey, "PingIP%d", g_nPingAddr);
        dwcb = GetPrivateProfileString(g_szSection, szKey, "", buf, sizeof(buf), szPath);
        if (dwcb == 0) 
            break;
        if (ConvertIP(buf) == NULL)
            goto badip;
    }

        //
        // use DNS servers if no IP addresses specified
        //
    if (g_nPingAddr == 0) {
    	lRetCode = RegOpenKeyEx(HKEY_LOCAL_MACHINE, 
                                "SYSTEM\\CurrentControlSet\\Services\\Tcpip\\Parameters",
    	                        0, KEY_READ, &hKey);
    	if (lRetCode != ERROR_SUCCESS)
            return FALSE;

    	dwcb = sizeof(buf);
    	lRetCode = RegQueryValueEx (hKey, "NameServer", NULL, NULL,
    	                          (LPBYTE) &buf, &dwcb);
    	lRetCode = RegCloseKey (hKey);

    	buf[sizeof(buf)-1] = 0; // ensure null termination
        psz = buf;
        while (TRUE) {
            while(*psz == ' ' || *psz == '\t') psz++;
            if (*psz == '\0') 
                break;
            psz = ConvertIP(psz);
            if (psz == NULL)
                goto badip;
            if (g_nPingAddr == MAX_PINGADDR) 
                break;
        }
    }

        //
        // must have at least 1 IP address if PingInterval specified
        //
    if (g_nPingAddr == 0)
        return FALSE;
    else
	    return TRUE;

badip:
    Trace(EVENT_ERROR, "Invalid IP address %s", buf);
    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
void WorkerThread(void* pVoid) 
{
    DWORD               dwResult; 
    RASCONNSTATUS       RasStatus;
    RASDIALPARAMS       RasParms;
    RASDIALEXTENSIONS   RasExtensions;
    TCHAR               szBuf[4096];
    HRASCONN            hRasConn;

    DWORD               dwBytes;
    DWORD               dwConnections;
    LPRASCONN           pRasConn;
    LPRASCONN           pRasConnBuf;

    BOOL                fLimitTraced;
    DWORD               CurHour;
    DWORD               PrevHour;
    DWORD               TryCount;

    HINSTANCE           hLibRas;
    RASDIAL             pRasDial;
    RASGETCONNECTSTATUS pRasGetConnectStatus;
    RASGETERRORSTRING   pRasGetErrorString;
    RASHANGUP           pRasHangUp;
    RASENUMCONNECTIONS  pRasEnumConnections;

    HINSTANCE           hLibIcmp;
    HANDLE              hIcmp;
    DWORD               PingCount;
    DWORD               PingFailures;
    DWORD               PingAddr;
    DWORD               PingIteration;
    DWORD               dwReplies;
    PICMP_ECHO_REPLY    pReply;
    ICMPCREATEFILE      pIcmpCreateFile;
    ICMPCLOSEHANDLE     pIcmpCloseHandle;
    ICMPSENDECHO        pIcmpSendEcho;
    TCHAR               szPingAddr[100];

        //
        // initialize
        //
    if (!ReadInitParms()) {
        SetEvent(g_hServDoneEvent);
        return;
    }

    if (!GetServiceNames()) {
        SetEvent(g_hServDoneEvent);
        return;
    }

    if (!GetPingAddresses()) {
        SetEvent(g_hServDoneEvent);
        return;
    }

    PingFailures = 0;
    PingCount = 0;
    PrevHour = 0;
    TryCount = 0;
    fLimitTraced = FALSE;

    wsprintf(szBuf, "Initialization complete, Entry=%s Domain=%s UsePrefixSuffix=%s "
                    "Phonebook=%s MaxTrysIn1Hour=%d, PingInterval=%d sec, "
                    "MaxPingFailures=%d, PingTimeout=%d msec, PingIterations=%d, "
                    "RedialInterval=%d, PingAddresses=",
                     g_szEntryName, g_szDomain, g_szUsePrefixSuffix,
                     g_szPhonebook, g_nMaxTrysIn1Hour, g_nPingInterval, 
                     g_nMaxPingFailures, g_nPingTimeout, g_nPingIterations,
                     g_nRedialInterval);
    for (PingAddr = 0; PingAddr < g_nPingAddr; PingAddr++) {
        wsprintf(szPingAddr, "%d.%d.%d.%d ",
                 g_PingAddr[PingAddr].S_un.S_un_b.s_b1,
                 g_PingAddr[PingAddr].S_un.S_un_b.s_b2,
                 g_PingAddr[PingAddr].S_un.S_un_b.s_b3,
                 g_PingAddr[PingAddr].S_un.S_un_b.s_b4);
        lstrcat(szBuf, szPingAddr);
    }
    Trace(EVENT_INFO, szBuf);

    hLibIcmp = LoadLibrary("ICMP");
    if (hLibIcmp == NULL) {
        Trace(EVENT_ERROR, "Unable to load ICMP.DLL, rc=%lu", GetLastError());
        SetEvent(g_hServDoneEvent);
        return;
    }
    pIcmpCreateFile = (ICMPCREATEFILE) GetProcAddress(hLibIcmp, "IcmpCreateFile");
    pIcmpCloseHandle = (ICMPCLOSEHANDLE) GetProcAddress(hLibIcmp, "IcmpCloseHandle");
    pIcmpSendEcho = (ICMPSENDECHO) GetProcAddress(hLibIcmp, "IcmpSendEcho");
    if (pIcmpCreateFile == NULL || pIcmpCloseHandle == NULL || pIcmpSendEcho == NULL) {
        Trace(EVENT_ERROR, "Unable to load ICMP entry points, rc=%lu", GetLastError());
        SetEvent(g_hServDoneEvent);
        goto freeicmp;
    }
    hIcmp = pIcmpCreateFile();
    if (hIcmp == INVALID_HANDLE_VALUE) {
        Trace(EVENT_ERROR, "IcmpCreateFile failed, rc=%lu", GetLastError());
        SetEvent(g_hServDoneEvent);
        goto freeicmp;
    }

        //
        // if ras connection is already established, just wait for it to end
        // (must load RASAPI32.DLL dynamically, otherwise service won't start properly)
        //
    hLibRas = LoadLibrary("RASAPI32");
    if (hLibRas == NULL) {
        Trace(EVENT_ERROR, "Unable to load RASAPI32.DLL, rc=%lu", GetLastError());
    }
    else {
        pRasDial = (RASDIAL) GetProcAddress(hLibRas, "RasDialA");
        pRasGetErrorString = (RASGETERRORSTRING) GetProcAddress(hLibRas, "RasGetErrorStringA");
        pRasGetConnectStatus = (RASGETCONNECTSTATUS) GetProcAddress(hLibRas, "RasGetConnectStatusA");
        pRasHangUp = (RASHANGUP) GetProcAddress(hLibRas, "RasHangUpA");
        pRasEnumConnections = (RASENUMCONNECTIONS) GetProcAddress(hLibRas, "RasEnumConnectionsA");
        if (pRasEnumConnections == NULL || pRasDial == NULL || pRasHangUp == NULL || 
            pRasGetErrorString == NULL || pRasGetConnectStatus == NULL ) 
        {
            Trace(EVENT_ERROR, "Unable to load Ras entry points, rc=%lu", GetLastError());
        }
        else {
            dwBytes = 300 * sizeof(RASCONN);
            pRasConnBuf = (LPRASCONN) malloc(dwBytes);
            if (pRasConnBuf == NULL) {
                Trace(EVENT_ERROR, "malloc for RasConnBuf failed");
                goto cleanup;
            }
            pRasConnBuf->dwSize = sizeof(RASCONN);
            dwResult = pRasEnumConnections(pRasConnBuf, &dwBytes, &dwConnections);
            if (dwResult == 0) {
                pRasConn = pRasConnBuf;
                while(dwConnections-- > 0) {
                    if (lstrcmpi(pRasConn->szEntryName, g_szEntryName) == 0) {
                        hRasConn = pRasConn->hrasconn;
                        free(pRasConnBuf);
                        goto waitloop;
                    }
                    pRasConn++;
                }
            }
            free(pRasConnBuf);
        }
        FreeLibrary(hLibRas);
    }

        //
        // main loop
        //
    while (TRUE) {
        if (WaitForSingleObject(g_hServDoneEvent, 0) == WAIT_OBJECT_0)
            goto cleanup;

            // 
            // Check for not too many dials per hour
            //
        if (g_nMaxTrysIn1Hour > 0) {
            while (TRUE) {
                CurHour = GetTickCount() / 3600000;
                if (CurHour != PrevHour)
                    TryCount = 0;
                PrevHour = CurHour;
                if (TryCount < g_nMaxTrysIn1Hour) 
                    break;
                if (!fLimitTraced) {
                    Trace(EVENT_ERROR, "TryCount=%d equals MaxTrysIn1Hour=%d, wait until next hour", 
                                       TryCount, g_nMaxTrysIn1Hour);
                    fLimitTraced = TRUE;
                }
                if (WaitForSingleObject(g_hServDoneEvent, 60000) == WAIT_OBJECT_0)
                    return;
            }
            fLimitTraced = FALSE;
        }

            //
            // must load RASAPI32.DLL dynamically, otherwise service won't start properly
            //
        hLibRas = LoadLibrary("RASAPI32");
        if (hLibRas == NULL) {
            Trace(EVENT_ERROR, "Unable to load RASAPI32.DLL, rc=%lu", GetLastError());
            goto sleep;
        }
        pRasDial = (RASDIAL) GetProcAddress(hLibRas, "RasDialA");
        pRasGetErrorString = (RASGETERRORSTRING) GetProcAddress(hLibRas, "RasGetErrorStringA");
        pRasGetConnectStatus = (RASGETCONNECTSTATUS) GetProcAddress(hLibRas, "RasGetConnectStatusA");
        pRasHangUp = (RASHANGUP) GetProcAddress(hLibRas, "RasHangUpA");
        pRasEnumConnections = (RASENUMCONNECTIONS) GetProcAddress(hLibRas, "RasEnumConnectionsA");
        if (pRasEnumConnections == NULL || pRasDial == NULL || pRasHangUp == NULL || 
            pRasGetErrorString == NULL || pRasGetConnectStatus == NULL ) 
        {
            //Trace(EVENT_ERROR, "Unable to load Ras entry points, rc=%lu", GetLastError());
            goto freelib;
        }

            // 
            // dial
            //
        ZeroMemory(&RasParms, sizeof(RasParms));
        RasParms.dwSize = sizeof(RASDIALPARAMS);
        lstrcpy(RasParms.szEntryName, g_szEntryName);
        lstrcpy(RasParms.szUserName, g_szUserName);
        lstrcpy(RasParms.szPassword, g_szPassword);
        if (lstrlen(g_szDomain) > 0)
            lstrcpy(RasParms.szDomain, g_szDomain);
        ZeroMemory(&RasExtensions, sizeof(RasExtensions));
        RasExtensions.dwSize = sizeof(RASDIALEXTENSIONS);
        if (g_szUsePrefixSuffix[0] == 'Y' || g_szUsePrefixSuffix[0] == 'y')
            RasExtensions.dwfOptions |= RDEOPT_UsePrefixSuffix;

        hRasConn = 0;
        dwResult = pRasDial(&RasExtensions, g_pszPhonebook, &RasParms, 0, NULL, &hRasConn);

        if (dwResult != ERROR_LINE_BUSY) 
            TryCount++;
    
        if (dwResult != 0) {
            if (dwResult != ERROR_LINE_BUSY) {
                if (pRasGetErrorString(dwResult, szBuf, sizeof(szBuf)) != 0)
                    Trace(EVENT_ERROR, "RasDial failed, rc=%lu", dwResult);
                else
                    Trace(EVENT_ERROR, "RasDial failed, rc=%lu %s", dwResult, szBuf);
            }
        }
        else {
            RasStatus.dwSize = sizeof(RasStatus);
            dwResult = pRasGetConnectStatus(hRasConn, &RasStatus);
            if (dwResult == 0 && RasStatus.rasconnstate == RASCS_Connected) {

                    // 
                    // start services, wait for disconnect, stop services
                    //
                Trace(EVENT_CONNECT, "Connected to %s", g_szEntryName);
                StartServices();
                while (TRUE) {
waitloop:
                    RasStatus.dwSize = sizeof(RasStatus);
                    dwResult = pRasGetConnectStatus(hRasConn, &RasStatus);
                    if (dwResult != 0 || RasStatus.rasconnstate != RASCS_Connected) {
                        Trace(EVENT_DISCONNECT, "Lost connection to %s", g_szEntryName);
                        break;
                    }

                        // wait 10 seconds
                    if (WaitForSingleObject(g_hServDoneEvent, 10000) == WAIT_OBJECT_0)
                        goto cleanup;

                    // notes: don't want to break and stop services, just leave
                    // ras connection and services running. If redial service is then 
                    // restarted, we should branch to waitloop label above.
                    PingCount++;
                    if (g_nPingInterval > 0 && PingCount * 10 >= g_nPingInterval) {
                        PingCount = 0;
                        for (PingAddr = 0; PingAddr < g_nPingAddr; PingAddr++) {
                            for (PingIteration = 0; 
                                 PingIteration < g_nPingIterations; 
                                 PingIteration++)
                            {
                                ZeroMemory(szBuf, sizeof(szBuf));
                                dwReplies = pIcmpSendEcho(hIcmp,
                                                         (IPAddr) g_PingAddr[PingAddr].s_addr,
                                                         NULL,
                                                         0,
                                                         NULL,
                                                         szBuf,
                                                         sizeof(szBuf),
                                                         g_nPingTimeout);
                                if (dwReplies > 0) {
                                    pReply = (PICMP_ECHO_REPLY) szBuf;
                                    if (pReply->Status == 0) {
                                        if (g_fVerbose) {
                                           Trace(EVENT_INFO, "Ping %d.%d.%d.%d successful",
                                                 g_PingAddr[PingAddr].S_un.S_un_b.s_b1,
                                                 g_PingAddr[PingAddr].S_un.S_un_b.s_b2,
                                                 g_PingAddr[PingAddr].S_un.S_un_b.s_b3,
                                                 g_PingAddr[PingAddr].S_un.S_un_b.s_b4);
                                        }
                                        PingFailures = 0;
                                        goto waitloop;
                                    }
                                }
                                if (g_fVerbose) {
                                   Trace(EVENT_ERROR, "Ping %d.%d.%d.%d failed",
                                         g_PingAddr[PingAddr].S_un.S_un_b.s_b1,
                                         g_PingAddr[PingAddr].S_un.S_un_b.s_b2,
                                         g_PingAddr[PingAddr].S_un.S_un_b.s_b3,
                                         g_PingAddr[PingAddr].S_un.S_un_b.s_b4);
                                }
                            }
                        }
                        PingFailures++;
                        if (g_nMaxPingFailures > 0 && PingFailures >= g_nMaxPingFailures) {
                            Trace(EVENT_PINGFAIL, "%d ping failures, dropping connection",
                                  PingFailures);
                            break;
                        }
                    }
                }
                StopServices();
            }
        }

            //
            // hang up
            //
        if (hRasConn != 0) {
            dwResult = pRasHangUp(hRasConn);
            while (dwResult != ERROR_INVALID_HANDLE) {
                RasStatus.dwSize = sizeof(RasStatus);
                dwResult = pRasGetConnectStatus(hRasConn, &RasStatus);
                Sleep(1000); // wait 1 second
            }
            hRasConn = 0;
        }

            //
            // free dynamically loaded RASAPI32.DLL
            //
freelib:
        FreeLibrary(hLibRas);

sleep:
        if (WaitForSingleObject(g_hServDoneEvent, g_nRedialInterval*1000) == WAIT_OBJECT_0)
            goto cleanup;
    }

cleanup:
    if (!pIcmpCloseHandle(hIcmp)) {
        // Trace(EVENT_ERROR, "IcmpCloseHandle failed, rc=%lu", GetLastError());
    }
freeicmp:
    FreeLibrary(hLibIcmp);
    return;
}
